<template>
  <v-form @submit="submitForm">
    <v-row>
      <v-col cols="12" md="6">
        <form-group :validator="$v.first_name" name="first_name">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="first_name"
              v-bind="attrs"
              @blur="$v.first_name.$touch()"
              label="First Name"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12" md="6">
        <form-group :validator="$v.email" name="email">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="email"
              v-bind="attrs"
              @blur="$v.email.$touch()"
              type="email"
              label="Email"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12" md="6">
        <form-group :validator="$v.password" name="password">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="password"
              v-bind="attrs"
              @blur="$v.password.$touch()"
              type="password"
              label="Password"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12" md="6">
        <form-group :validator="$v.phone" name="phone">
          <template slot-scope="{ attrs }">
            <v-text-field
              v-model="phone"
              v-bind="attrs"
              @blur="$v.phone.$touch()"
              label="Phone"
              outlined
            ></v-text-field>
          </template>
        </form-group>
      </v-col>
      <v-col cols="12">
        <v-btn type="submit" variant="primary">Register</v-btn>
      </v-col>
    </v-row>
  </v-form>
</template>

<script>
import { required, email, numeric } from 'vuelidate/lib/validators'

export default {
  name: 'LoginPage',
  middleware: 'guest',

  data() {
    return {
      first_name: '',
      password: '',
      email: '',
      phone: null
    }
  },

  created() {
    console.log(this.$store.$auth)
  },
  methods: {
    async submitForm() {
      try {
        await this.$axios.post('signup', {
          first_name: this.first_name,
          email: this.email,
          password: this.password,
          phone: this.phone,
          gender: 1,
          birthdate: '1995-10-10'
        })

        await this.$auth.loginWith('local', {
          data: {
            username: this.email,
            password: this.password
          }
        })

        this.$router.push('/')
      } catch (e) {
        console.log('TCL: e', e)
        this.error = e.response.data.message
      }
    }

    // async submitForm(evt) {
    //   evt.preventDefault()
    //   const credentials = {
    //     username: this.username,
    //     password: this.password
    //   }
    //   try {
    //     await this.$auth.loginWith('local', {
    //       data: credentials
    //     })
    //     this.$router.push('/')
    //   } catch (e) {
    //     this.$router.push('/login')
    //   }
    // }
  },
  validations() {
    return {
      first_name: {
        required
      },
      password: {
        required
      },
      email: {
        required,
        email
      },
      phone: {
        required,
        numeric
      }
    }
  }
}
</script>
